> For the complete documentation index, see [llms.txt](https://initia.gitbook.io/initia/kBNuZF5MglV9d3zOOUeW/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://initia.gitbook.io/initia/kBNuZF5MglV9d3zOOUeW/developers/virtual-machines/movevm.md).

# MoveVM

Initia's MoveVM is a wrapper which connects Move Runtime to CosmosSDK, implemented with the method used by WasmVM created by CosmWasm to connect Rust implemented MoveVM runtime to golang implemented Cosmos chain.&#x20;

Going beyond just connection, to prevent having two different coin standard within one chain, the bank module of CosmosSDK has been modified to use Move coin only. Also, native staking is presented in a form of LSD (Liquid Staking Module) so that Move users can use Cosmos Staking features.&#x20;

The below CosmosSDK messages are provided on Move.

### Supported Cosmos Messages

| Module       | Msg                     |
| ------------ | ----------------------- |
| Staking      | `delegate`              |
| Distribution | `fund_community_pool`   |
| IBC          | `transfer`              |
| IBC          | `nft_transfer`          |
| IBC          | `pay_fee`               |
| OPinit       | `initiate_token_bridge` |

Refer to the links below to learn more about Initia Move.

* [Move Book](https://aptos.dev/move/book/SUMMARY)
* [Object Model](https://aptos.dev/standards/aptos-object)
  * [Fungible Asset Standard](https://aptos.dev/standards/fungible-asset)
  * [Digital Asset Standard](https://aptos.dev/standards/digital-asset)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://initia.gitbook.io/initia/kBNuZF5MglV9d3zOOUeW/developers/virtual-machines/movevm.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
